window.Gleam.initSearch([{"doc":"franz","title":"franz","content":"# franz\n\n[![Package Version](https://img.shields.io/hexpm/v/franz)](https://hex.pm/packages/franz)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/franz/)\n\n`franz` is a Gleam library for interacting with Kafka. It provides functionalities to produce and consume messages, handle topics, and manage configurations.\n\n## Installation\n\nAdd `franz` to your Gleam project:\n\n```sh\ngleam add franz\n```\n","url":"index.html"},{"doc":"franz","title":"Ack","content":"pub type Ack\n\n\nSynonyms:\nfranz.Ack\nfranz Ack","url":"franz.html#Ack"},{"doc":"franz","title":"AckOrCommit","content":"pub type AckOrCommit(callback_state)\n\n\nSynonyms:\nfranz.AckOrCommit\nfranz AckOrCommit","url":"franz.html#AckOrCommit"},{"doc":"franz","title":"ClientConfig","content":"pub type ClientConfig {\n  RestartDelaySeconds(Int)\n  GetMetadataTimeoutSeconds(Int)\n  ReconnectCoolDownSeconds(Int)\n  AllowTopicAutoCreation(Bool)\n  AutoStartProducers(Bool)\n  DefaultProducerConfig(List(ProducerConfig))\n  UnknownTopicCacheTtl(Int)\n}\n\nRestartDelaySeconds(Int)\n\n\nGetMetadataTimeoutSeconds(Int)\n\n\nReconnectCoolDownSeconds(Int)\n\n\nAllowTopicAutoCreation(Bool)\n\n\nAutoStartProducers(Bool)\n\n\nDefaultProducerConfig(List(ProducerConfig))\n\n\nUnknownTopicCacheTtl(Int)\n\n\nSynonyms:\nfranz.ClientConfig\nfranz ClientConfig","url":"franz.html#ClientConfig"},{"doc":"franz","title":"Commit","content":"pub type Commit\n\n\nSynonyms:\nfranz.Commit\nfranz Commit","url":"franz.html#Commit"},{"doc":"franz","title":"Compression","content":"pub type Compression {\n  NoCompression\n  Gzip\n  Snappy\n}\n\nNoCompression\n\n\nGzip\n\n\nSnappy\n\n\nSynonyms:\nfranz.Compression\nfranz Compression","url":"franz.html#Compression"},{"doc":"franz","title":"ConsumerConfig","content":"pub type ConsumerConfig {\n  BeginOffset(OffsetTime)\n  MinBytes(Int)\n  MaxBytes(Int)\n  MaxWaitTime(Int)\n  SleepTimeout(Int)\n  PrefetchCount(Int)\n  PrefetchBytes(Int)\n  OffsetResetPolicy(OffsetResetPolicy)\n  SizeStatWindow(Int)\n  IsolationLevel(IsolationLevel)\n  ShareLeaderConn(Bool)\n}\n\nBeginOffset(OffsetTime)\n\n\nMinBytes(Int)\n\n\nMaxBytes(Int)\n\n\nMaxWaitTime(Int)\n\n\nSleepTimeout(Int)\n\n\nPrefetchCount(Int)\n\n\nPrefetchBytes(Int)\n\n\nOffsetResetPolicy(OffsetResetPolicy)\n\n\nSizeStatWindow(Int)\n\n\nIsolationLevel(IsolationLevel)\n\n\nShareLeaderConn(Bool)\n\n\nSynonyms:\nfranz.ConsumerConfig\nfranz ConsumerConfig","url":"franz.html#ConsumerConfig"},{"doc":"franz","title":"ConsumerPartition","content":"pub type ConsumerPartition {\n  ConsumerPartitions(List(Int))\n  All\n}\n\nConsumerPartitions(List(Int))\n\n\nAll\n\n\nSynonyms:\nfranz.ConsumerPartition\nfranz ConsumerPartition","url":"franz.html#ConsumerPartition"},{"doc":"franz","title":"FranzClient","content":"pub type FranzClient\n\n\nSynonyms:\nfranz.FranzClient\nfranz FranzClient","url":"franz.html#FranzClient"},{"doc":"franz","title":"FranzError","content":"pub type FranzError {\n  UnknownError\n  ClientDown\n  UnknownTopicOrPartition\n  ProducerDown\n  TopicAlreadyExists\n  ConsumerNotFound(String)\n  ProducerNotFound(String, Int)\n}\n\nUnknownError\n\n\nClientDown\n\n\nUnknownTopicOrPartition\n\n\nProducerDown\n\n\nTopicAlreadyExists\n\n\nConsumerNotFound(String)\n\n\nProducerNotFound(String, Int)\n\n\nSynonyms:\nfranz.FranzError\nfranz FranzError","url":"franz.html#FranzError"},{"doc":"franz","title":"GroupConfig","content":"pub type GroupConfig {\n  SessionTimeoutSeconds(Int)\n  RebalanceTimeoutSeconds(Int)\n  HeartbeatRateSeconds(Int)\n  MaxRejoinAttempts(Int)\n  RejoinDelaySeconds(Int)\n  OffsetCommitIntervalSeconds(Int)\n  OffsetRetentionSeconds(Int)\n}\n\nSessionTimeoutSeconds(Int)\n\n\nRebalanceTimeoutSeconds(Int)\n\n\nHeartbeatRateSeconds(Int)\n\n\nMaxRejoinAttempts(Int)\n\n\nRejoinDelaySeconds(Int)\n\n\nOffsetCommitIntervalSeconds(Int)\n\n\nOffsetRetentionSeconds(Int)\n\n\nSynonyms:\nfranz.GroupConfig\nfranz GroupConfig","url":"franz.html#GroupConfig"},{"doc":"franz","title":"IsolationLevel","content":"pub type IsolationLevel {\n  ReadCommitted\n  ReadUncommitted\n}\n\nReadCommitted\n\n\nReadUncommitted\n\n\nSynonyms:\nfranz.IsolationLevel\nfranz IsolationLevel","url":"franz.html#IsolationLevel"},{"doc":"franz","title":"KafkaMessage","content":"pub type KafkaMessage {\n  KafkaMessage(\n    offset: Int,\n    key: BitArray,\n    value: BitArray,\n    timestamp_type: TimeStampType,\n    timestamp: Int,\n    headers: List(#(String, String)),\n  )\n  KafkaMessageSet(\n    topic: Topic,\n    partition: Int,\n    high_wm_offset: Int,\n    messages: List(KafkaMessage),\n  )\n}\n\nKafkaMessage(\n  offset: Int,\n  key: BitArray,\n  value: BitArray,\n  timestamp_type: TimeStampType,\n  timestamp: Int,\n  headers: List(#(String, String)),\n)\n\n\nKafkaMessageSet(\n  topic: Topic,\n  partition: Int,\n  high_wm_offset: Int,\n  messages: List(KafkaMessage),\n)\n\n\nSynonyms:\nfranz.KafkaMessage\nfranz KafkaMessage","url":"franz.html#KafkaMessage"},{"doc":"franz","title":"MessageType","content":"pub type MessageType {\n  Message\n  MessageSet\n}\n\nMessage\n\n\nMessageSet\n\n\nSynonyms:\nfranz.MessageType\nfranz MessageType","url":"franz.html#MessageType"},{"doc":"franz","title":"Offset","content":"pub type Offset =\n  Int\n\n\nSynonyms:\nfranz.Offset\nfranz Offset","url":"franz.html#Offset"},{"doc":"franz","title":"OffsetResetPolicy","content":"pub type OffsetResetPolicy {\n  ResetBySubscriber\n  ResetToEarliest\n  ResetToLatest\n}\n\nResetBySubscriber\n\n\nResetToEarliest\n\n\nResetToLatest\n\n\nSynonyms:\nfranz.OffsetResetPolicy\nfranz OffsetResetPolicy","url":"franz.html#OffsetResetPolicy"},{"doc":"franz","title":"OffsetTime","content":"pub type OffsetTime {\n  Earliest\n  Latest\n  MessageTimestamp(Int)\n}\n\nEarliest\n\n\nLatest\n\n\nMessageTimestamp(Int)\n\n\nSynonyms:\nfranz.OffsetTime\nfranz OffsetTime","url":"franz.html#OffsetTime"},{"doc":"franz","title":"Partition","content":"pub type Partition =\n  Int\n\n\nSynonyms:\nfranz.Partition\nfranz Partition","url":"franz.html#Partition"},{"doc":"franz","title":"Partitioner","content":"pub type Partitioner {\n  PartitionFun(\n    fn(String, Int, BitArray, BitArray) -&gt; Result(Int, Nil),\n  )\n  Random\n  Hash\n}\n\nPartitionFun(\n  fn(String, Int, BitArray, BitArray) -&gt; Result(Int, Nil),\n)\n\n\nRandom\n\n\nHash\n\n\nSynonyms:\nfranz.Partitioner\nfranz Partitioner","url":"franz.html#Partitioner"},{"doc":"franz","title":"ProducerConfig","content":"pub type ProducerConfig {\n  RequiredAcks(Int)\n  AckTimeout(Int)\n  PartitionBufferLimit(Int)\n  PartitionOnwireLimit(Int)\n  MaxBatchSize(Int)\n  MaxRetries(Int)\n  RetryBackoffMs(Int)\n  Compression(Compression)\n  MaxLingerMs(Int)\n  MaxLingerCount(Int)\n}\n\nRequiredAcks(Int)\n\n\nAckTimeout(Int)\n\n\nPartitionBufferLimit(Int)\n\n\nPartitionOnwireLimit(Int)\n\n\nMaxBatchSize(Int)\n\n\nMaxRetries(Int)\n\n\nRetryBackoffMs(Int)\n\n\nCompression(Compression)\n\n\nMaxLingerMs(Int)\n\n\nMaxLingerCount(Int)\n\n\nSynonyms:\nfranz.ProducerConfig\nfranz ProducerConfig","url":"franz.html#ProducerConfig"},{"doc":"franz","title":"ProducerPartition","content":"pub type ProducerPartition {\n  Partition(Int)\n  Partitioner(Partitioner)\n}\n\nPartition(Int)\n\n\nPartitioner(Partitioner)\n\n\nSynonyms:\nfranz.ProducerPartition\nfranz ProducerPartition","url":"franz.html#ProducerPartition"},{"doc":"franz","title":"TimeStampType","content":"pub type TimeStampType {\n  Undefined\n  Create\n  Append\n}\n\nUndefined\n\n\nCreate\n\n\nAppend\n\n\nSynonyms:\nfranz.TimeStampType\nfranz TimeStampType","url":"franz.html#TimeStampType"},{"doc":"franz","title":"Topic","content":"pub type Topic =\n  String\n\n\nSynonyms:\nfranz.Topic\nfranz Topic","url":"franz.html#Topic"},{"doc":"franz","title":"Value","content":"pub type Value {\n  Value(value: BitArray, headers: List(#(String, String)))\n  ValueWithTimestamp(\n    value: BitArray,\n    timestamp: Int,\n    headers: List(#(String, String)),\n  )\n}\n\nValue(value: BitArray, headers: List(#(String, String)))\n\n\nValueWithTimestamp(\n  value: BitArray,\n  timestamp: Int,\n  headers: List(#(String, String)),\n)\n\n\nSynonyms:\nfranz.Value\nfranz Value","url":"franz.html#Value"},{"doc":"franz","title":"ack_return","content":"pub fn ack_return(cb_state: a) -&gt; AckOrCommit(Ack)\n\nSynonyms:\nfranz.ack_return\nfranz ack_return","url":"franz.html#ack_return"},{"doc":"franz","title":"commit_return","content":"pub fn commit_return(cb_state: a) -&gt; AckOrCommit(Commit)\n\nSynonyms:\nfranz.commit_return\nfranz commit_return","url":"franz.html#commit_return"},{"doc":"franz","title":"create_topic","content":"pub fn create_topic(\n  bootstrap_endpoints: List(#(String, Int)),\n  topic: String,\n  partitions: Int,\n  replication_factor: Int,\n) -&gt; Result(Nil, FranzError)\n\nSynonyms:\nfranz.create_topic\nfranz create_topic","url":"franz.html#create_topic"},{"doc":"franz","title":"fetch","content":"pub fn fetch(\n  client: FranzClient,\n  topic: String,\n  partition: Int,\n  offset: Int,\n) -&gt; Result(#(Int, KafkaMessage), FranzError)\n\nSynonyms:\nfranz.fetch\nfranz fetch","url":"franz.html#fetch"},{"doc":"franz","title":"produce","content":"pub fn produce(\n  client: FranzClient,\n  topic: String,\n  partition: ProducerPartition,\n  key: BitArray,\n  value: Value,\n) -&gt; Result(Nil, FranzError)\n\nSynonyms:\nfranz.produce\nfranz produce","url":"franz.html#produce"},{"doc":"franz","title":"produce_cb","content":"pub fn produce_cb(\n  client: FranzClient,\n  topic: String,\n  partition: ProducerPartition,\n  key: BitArray,\n  value: Value,\n  callback: fn(Int, Int) -&gt; a,\n) -&gt; Result(Int, FranzError)\n\nSynonyms:\nfranz.produce_cb\nfranz produce_cb","url":"franz.html#produce_cb"},{"doc":"franz","title":"produce_sync","content":"pub fn produce_sync(\n  client: FranzClient,\n  topic: String,\n  partition: ProducerPartition,\n  key: BitArray,\n  value: Value,\n) -&gt; Result(Nil, FranzError)\n\nSynonyms:\nfranz.produce_sync\nfranz produce_sync","url":"franz.html#produce_sync"},{"doc":"franz","title":"produce_sync_offset","content":"pub fn produce_sync_offset(\n  client: FranzClient,\n  topic: String,\n  partition: ProducerPartition,\n  key: BitArray,\n  value: Value,\n) -&gt; Result(Int, FranzError)\n\nSynonyms:\nfranz.produce_sync_offset\nfranz produce_sync_offset","url":"franz.html#produce_sync_offset"},{"doc":"franz","title":"start_client","content":"pub fn start_client(\n  bootstrap_endpoints: List(#(String, Int)),\n  client_config: List(ClientConfig),\n) -&gt; Result(FranzClient, FranzError)\n\nSynonyms:\nfranz.start_client\nfranz start_client","url":"franz.html#start_client"},{"doc":"franz","title":"start_consumer","content":"pub fn start_consumer(\n  client: FranzClient,\n  topic: String,\n  options: List(ConsumerConfig),\n) -&gt; Result(Nil, FranzError)\n\nSynonyms:\nfranz.start_consumer\nfranz start_consumer","url":"franz.html#start_consumer"},{"doc":"franz","title":"start_group_subscriber","content":"pub fn start_group_subscriber(\n  client: FranzClient,\n  group_id: String,\n  topics: List(String),\n  consumer_config: List(ConsumerConfig),\n  group_config: List(GroupConfig),\n  message_type: MessageType,\n  callback: fn(KafkaMessage, a) -&gt; AckOrCommit(b),\n  init_callback_state: c,\n) -&gt; Result(Pid, FranzError)\n\nSynonyms:\nfranz.start_group_subscriber\nfranz start_group_subscriber","url":"franz.html#start_group_subscriber"},{"doc":"franz","title":"start_topic_subscriber","content":"pub fn start_topic_subscriber(\n  client: FranzClient,\n  topic: String,\n  partitions: ConsumerPartition,\n  consumer_config: List(ConsumerConfig),\n  commited_offsets_by_partition: List(#(Int, Int)),\n  message_type: MessageType,\n  callback: fn(Int, KafkaMessage, a) -&gt; AckOrCommit(Ack),\n  init_callback_state: a,\n) -&gt; Result(Pid, FranzError)\n\nSynonyms:\nfranz.start_topic_subscriber\nfranz start_topic_subscriber","url":"franz.html#start_topic_subscriber"},{"doc":"franz","title":"stop_client","content":"pub fn stop_client(client: FranzClient) -&gt; Nil\n\nSynonyms:\nfranz.stop_client\nfranz stop_client","url":"franz.html#stop_client"},{"doc":"franz","title":"franz","content":"","url":"franz.html"}]);